

class AdapGL:
    """
              Yasuharu Okamoto
                               2016.10

    """
    
    x = [ -9.68160239507626090E-0001,
	  -8.36031107326635794E-0001,
	  -6.13371432700590397E-0001,
	  -3.24253423403808929E-0001,
           0.00000000000000000E+0000,
	   3.24253423403808929E-0001,
	   6.13371432700590397E-0001,
	   8.36031107326635794E-0001,
	   9.68160239507626090E-0001 ]
    
    w = [  8.12743883615744120E-0002,
	   1.80648160694857404E-0001,
	   2.60610696402935462E-0001,
	   3.12347077040002840E-0001,
	   3.30239355001259763E-0001,
	   3.12347077040002840E-0001,
	   2.60610696402935462E-0001,
	   1.80648160694857404E-0001,
	   8.12743883615744120E-0002  ]

    def __init__(self):
        pass

    def gl(self, a, b):
                v1 = 0.0
                i_w = b - a
                for i in range(0, 9):
                    xi = (0.5 * i_w * AdapGL.x[i]) + (0.5 * (b + a))
                    v1 += AdapGL.w[i] * self.f.v(xi)

                v1 = 0.5 * i_w * v1
                return v1
                                                    
    def calc(self, s0, a, b):
                s1 = self.gl( a, 0.5 * (a + b))
                s2 = self.gl(0.5 * (a + b), b)
                if ((abs(s0 - s1 - s2) < (1.0e-14) * abs(s1 + s2))
                    or
                    (((abs(s0) + abs(s1 + s2)) < 1.0e-14)
                     and
                     (abs(b - a) < 1.0))):
                    return s1 + s2
                else:
                    s1 = self.calc(s1, a, 0.5 * (a + b))
                    s2 = self.calc(s2, 0.5 * (a + b), b)
                    return s1 + s2
                                                    
    def integral(self, a, b, f):
                self.f = f
                v = 0.0
                v = self.calc( v, a, b )

                return v
