from Calc_p_from_chi2 import calc_p

class Ccalc_chi2_XTbl:
    def __init__(self, data):
        self.data = data

    def calc(self):

        R = len(self.data)
        C = len(self.data[0])
        N = R * C

        Rsum = []
        for v in self.data:
            sum = 0
            for x in v:
                sum += x
            Rsum.append(sum)

        Total = 0
        Csum = []
        for i in range(0, C):
            sum = 0
            for j in range(0, R):
                sum += self.data[j][i]
            Csum.append(sum)
            Total += sum

        E = []
        for i in range(0, R):
            E.append([])
            for j in range(0, C):
                E[i].append(Rsum[i] * Csum[j] / float(Total))

        print("\nObs./E =")
        for i in range(0, R):
            for j in range(0, C):
                print("{0:7d}/{1:<7.2f}".format(self.data[i][j], E[i][j]), end  = " ")
            print(" ")
        print(" ")
        chi2 = 0.0
        for i in range(0, R):
            for j in range(0, C):
                chi2 += ((self.data[i][j] - E[i][j]) ** 2.0) / E[i][j]
        df = (R - 1) * (C - 1)
        p = calc_p(chi2, df)

        return chi2, df, p

